﻿unit OpenJpeg21Fncs;

{******************************************************************************
 *
 * define function name in DLL for openjp2.dll v2.5.0
 *
 * rev. 1
 * auth ICHIMARU Takeshi ( http://homepage1.nifty.com/Ayakawa/ )
 * date 2014/11/07
 * memo apart from OPenJpeg21.pas
 *
 * rev. 2
 * auth ICHIMARU Takeshi ( http://ayakawa.o.oo7.jp )
 * date 2016/10/27
 * memo from OpenJPEG ver 2.1.2
 *
 * rev. 3
 * auth ICHIMARU Takeshi ( http://ayakawa.o.oo7.jp )
 * date 2017/08/10
 * memo from OpenJPEG ver 2.2.0
 *
 * rev. 4
 * auth ICHIMARU Takeshi ( http://ayakawa.o.oo7.jp )
 * date 2017/10/05
 * memo from OpenJPEG ver 2.3.0
 *
 * rev. 5
 * auth ICHIMARU Takeshi ( http://ayakawao.oo7.jp )
 * date 2021/01/10
 * memo from OpenJPEG ver 2.4.0
 *
 * rev. 6
 * auth ICHIMARU Takeshi ( http://ayakawao.oo7.jp )
 * date 2022/05/15
 * memo from OpenJPEG ver 2.5.0
 *
 * The copyright in this software is being made available under the 2-clauses
 * BSD License, included below. This software may be subject to other third
 * party and contributor rights, including patent rights, and no such rights
 * are granted under this license.
 *
 * Copyright (C) 2014-2021, ICHIMARU Takeshi ( http://ayakawa.o.oo7.jp )
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS `AS IS'
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 ******************************************************************************}

interface

const
{$IFDEF WIN64}
  S_OPJ_VERSION = 'opj_version';

  S_OPJ_IMAGE_CREATE      = 'opj_image_create';
  S_OPJ_IMAGE_DESTROY     = 'opj_image_destroy';
  S_OPJ_IMAGE_TILE_CREATE = 'opj_image_tile_create';

  S_OPJ_IMAGE_DATA_ALLOC  = 'opj_image_data_alloc';
  S_OPJ_IMAGE_DATA_FREE   = 'opj_image_data_free';

  S_OPJ_STREAM_DEFAULT_CREATE             = 'opj_stream_default_create';
  S_OPJ_STREAM_CREATE                     = 'opj_stream_create';
  S_OPJ_STREAM_DESTROY                    = 'opj_stream_destroy';
  S_OPJ_STREAM_SET_READ_FUNCTION          = 'opj_stream_set_read_function';
  S_OPJ_STREAM_SET_WRITE_FUNCTION         = 'opj_stream_set_write_function';
  S_OPJ_STREAM_SET_SKIP_FUNCTION          = 'opj_stream_set_skip_function';
  S_OPJ_STREAM_SET_SEEK_FUNCTION          = 'opj_stream_set_seek_function';
  S_OPJ_STREAM_SET_USER_DATA              = 'opj_stream_set_user_data';
  S_OPJ_STREAM_SET_USER_DATA_LENGTH       = 'opj_stream_set_user_data_length';
  S_OPJ_STREAM_CREATE_DEFAULT_FILE_STREAM = 'opj_stream_create_default_file_stream';
  S_OPJ_STREAM_CREATE_FILE_STREAM         = 'opj_stream_create_file_stream';

  S_OPJ_SET_INFO_HANDLER    = 'opj_set_info_handler';
  S_OPJ_SET_WARNING_HANDLER = 'opj_set_warning_handler';
  S_OPJ_SET_ERROR_HANDLER   = 'opj_set_error_handler';

  S_OPJ_CREATE_DECOMPRESS              = 'opj_create_decompress';
  S_OPJ_DESTROY_CODEC                  = 'opj_destroy_codec';
  S_OPJ_END_DECOMPRESS                 = 'opj_end_decompress';
  S_OPJ_SET_DEFAULT_DECODER_PARAMETERS = 'opj_set_default_decoder_parameters';
  S_OPJ_SETUP_DECODER                  = 'opj_setup_decoder';
  S_OPJ_DECODER_SET_STRICT_MODE        = 'opj_decoder_set_strict_mode';
  S_OPJ_CODEC_SET_THREADS              = 'opj_codec_set_threads';
  S_OPJ_READ_HEADER                    = 'opj_read_header';
  S_OPJ_SET_DECODED_COMPONENTS         = 'opj_set_decoded_components';
  S_OPJ_SET_DECODE_AREA                = 'opj_set_decode_area';
  S_OPJ_DECODE                         = 'opj_decode';
  S_OPJ_GET_DECODED_TILE               = 'opj_get_decoded_tile';
  S_OPJ_SET_DECODED_RESOLUTION_FACTOR  = 'opj_set_decoded_resolution_factor';
  S_OPJ_WRITE_TILE                     = 'opj_write_tile';
  S_OPJ_READ_TILE_HEADER               = 'opj_read_tile_header';
  S_OPJ_DECODE_TILE_DATA               = 'opj_decode_tile_data';
  S_OPJ_CREATE_COMPRESS                = 'opj_create_compress';
  S_OPJ_SET_DEFAULT_ENCODER_PARAMETERS = 'opj_set_default_encoder_parameters';
  S_OPJ_SETUP_ENCODER                  = 'opj_setup_encoder';
  S_OPJ_ENCODER_SET_EXTRA_OPTIONS      = 'opj_encoder_set_extra_options';
  S_OPJ_START_COMPRESS                 = 'opj_start_compress';
  S_OPJ_END_COMPRESS                   = 'opj_end_compress';
  S_OPJ_ENCODE                         = 'opj_encode';

  S_OPJ_SET_MCT = 'opj_set_MCT';

  S_OPJ_HAS_THREAD_SUPPORT             = 'opj_has_thread_support';
  S_OPJ_GET_NUM_CPUS                   = 'opj_get_num_cpus';
{$ELSE}
  S_OPJ_VERSION = '_opj_version@0';

  S_OPJ_IMAGE_DATA_ALLOC  = '_opj_image_data_alloc@4';
  S_OPJ_IMAGE_DATA_FREE   = '_opj_image_data_free@4';

  S_OPJ_IMAGE_CREATE      = '_opj_image_create@12';
  S_OPJ_IMAGE_DESTROY     = '_opj_image_destroy@4';
  S_OPJ_IMAGE_TILE_CREATE = '_opj_image_tile_create@12';

  S_OPJ_STREAM_DEFAULT_CREATE             = '_opj_stream_default_create@4';
  S_OPJ_STREAM_CREATE                     = '_opj_stream_create@8';
  S_OPJ_STREAM_DESTROY                    = '_opj_stream_destroy@4';
  S_OPJ_STREAM_SET_READ_FUNCTION          = '_opj_stream_set_read_function@8';
  S_OPJ_STREAM_SET_WRITE_FUNCTION         = '_opj_stream_set_write_function@8';
  S_OPJ_STREAM_SET_SKIP_FUNCTION          = '_opj_stream_set_skip_function@8';
  S_OPJ_STREAM_SET_SEEK_FUNCTION          = '_opj_stream_set_seek_function@8';
  S_OPJ_STREAM_SET_USER_DATA              = '_opj_stream_set_user_data@12';
  S_OPJ_STREAM_SET_USER_DATA_LENGTH       = '_opj_stream_set_user_data_length@12';
  S_OPJ_STREAM_CREATE_DEFAULT_FILE_STREAM = '_opj_stream_create_default_file_stream@8';
  S_OPJ_STREAM_CREATE_FILE_STREAM         = '_opj_stream_create_file_stream@12';

  S_OPJ_SET_INFO_HANDLER    = '_opj_set_info_handler@12';
  S_OPJ_SET_WARNING_HANDLER = '_opj_set_warning_handler@12';
  S_OPJ_SET_ERROR_HANDLER   = '_opj_set_error_handler@12';

  S_OPJ_CREATE_DECOMPRESS              = '_opj_create_decompress@4';
  S_OPJ_DESTROY_CODEC                  = '_opj_destroy_codec@4';
  S_OPJ_END_DECOMPRESS                 = '_opj_end_decompress@8';
  S_OPJ_SET_DEFAULT_DECODER_PARAMETERS = '_opj_set_default_decoder_parameters@4';
  S_OPJ_SETUP_DECODER                  = '_opj_setup_decoder@8';
  S_OPJ_DECODER_SET_STRICT_MODE        = '_opj_decoder_set_strict_mode@8';
  S_OPJ_CODEC_SET_THREADS              = '_opj_codec_set_threads@8';
  S_OPJ_READ_HEADER                    = '_opj_read_header@12';
  S_OPJ_SET_DECODED_COMPONENTS         = '_opj_set_decoded_components@16';
  S_OPJ_SET_DECODE_AREA                = '_opj_set_decode_area@24';
  S_OPJ_DECODE                         = '_opj_decode@12';
  S_OPJ_GET_DECODED_TILE               = '_opj_get_decoded_tile@16';
  S_OPJ_SET_DECODED_RESOLUTION_FACTOR  = '_opj_set_decoded_resolution_factor@8';
  S_OPJ_WRITE_TILE                     = '_opj_write_tile@20';
  S_OPJ_READ_TILE_HEADER               = '_opj_read_tile_header@40';
  S_OPJ_DECODE_TILE_DATA               = '_opj_decode_tile_data@20';
  S_OPJ_CREATE_COMPRESS                = '_opj_create_compress@4';
  S_OPJ_SET_DEFAULT_ENCODER_PARAMETERS = '_opj_set_default_encoder_parameters@4';
  S_OPJ_SETUP_ENCODER                  = '_opj_setup_encoder@12';
  S_OPJ_ENCODER_SET_EXTRA_OPTIONS      = '_opj_encoder_set_extra_options@8';
  S_OPJ_START_COMPRESS                 = '_opj_start_compress@12';
  S_OPJ_END_COMPRESS                   = '_opj_end_compress@8';
  S_OPJ_ENCODE                         = '_opj_encode@8';

  S_OPJ_SET_MCT = '_opj_set_MCT@16';

  S_OPJ_HAS_THREAD_SUPPORT             = '_opj_has_thread_support@0';
  S_OPJ_GET_NUM_CPUS                   = '_opj_get_num_cpus@0';
{$ENDIF}

implementation

end.
