﻿unit testf;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, Vcl.ExtCtrls, Vcl.ExtDlgs,
  Vcl.ComCtrls;

type
  TForm1 = class(TForm)
    Button1: TButton;
    OpenPicDlg: TOpenPictureDialog;
    ScrollBox1: TScrollBox;
    Image: TImage;
    Button2: TButton;
    Button3: TButton;
    CheckBox1: TCheckBox;
    TrackBar1: TTrackBar;
    Label2: TLabel;
    OpenJP2Dlg: TOpenPictureDialog;
    SaveJP2Dlg: TSavePictureDialog;
    Button4: TButton;
    StsBar: TStatusBar;
    Label1: TLabel;
    ThreadNumUpDown: TUpDown;
    ThreadNumEd: TEdit;
    ColorProfileCBox: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private 宣言 }
  public
    { Public 宣言 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
  OpenJpeg21,jpeg2kbitmap,jpeg,pngimage,gifimage;

procedure TForm1.Button1Click(Sender: TObject);
var
  jpg2kbmp : TJpeg2000Bitmap;
begin
  OpenJP2Dlg.Filter:='Jpeg2000|*.jp2;*.j2k;*.jpc;*.jpf';
  if not OpenJP2Dlg.Execute then exit;
  //
  StsBar.SimpleText:=OpenJP2Dlg.FileName;
  //
  jpg2kbmp:=TJpeg2000Bitmap.Create;
  try
    jpg2kbmp.UseColorProfile:=ColorProfileCBox.Checked;
    jpg2kbmp.ThreadNum:=ThreadNumUpDown.Position;
    jpg2kbmp.LoadFromFile(OpenJP2Dlg.FileName);
    image.Picture.Assign(jpg2kbmp);
    Button3.Enabled:=true;
    CheckBox1.Enabled:=true;
    TrackBar1.Enabled:=true;
    Label2.Enabled:=true;
  finally
    jpg2kbmp.Free;
  end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  if not OpenPicDlg.Execute then exit;
  //
  StsBar.SimpleText:=OpenPicDlg.FileName;
  image.Picture.LoadFromFile(OpenPicDlg.FileName);
  if EnabledJpeg2K then begin
    Button3.Enabled:=true;
    CheckBox1.Enabled:=true;
    TrackBar1.Enabled:=true;
    Label2.Enabled:=true;
  end;
end;

procedure TForm1.Button3Click(Sender: TObject);
var
  jp2 : TJpeg2000Bitmap;
begin
  SaveJP2Dlg.Filter:='Jpeg2000|*.jp2';
  if not SaveJP2Dlg.Execute then exit;
  //
  jp2:=TJpeg2000Bitmap.Create;
  try
    jp2.assign(image.Picture.Graphic);
    jp2.LosslessCompression:=CheckBox1.Checked;
    jp2.CompressionQuality:=TrackBar1.Position;
    jp2.SaveToFile(SaveJP2Dlg.FileName);
  finally
    jp2.free;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  image.Picture.Assign(nil);
  StsBar.SimpleText:='';
  if EnabledJpeg2K then begin
    Button3.Enabled:=false;
    CheckBox1.Enabled:=false;
    TrackBar1.Enabled:=false;
    Label2.Enabled:=false;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  LoadOpenJp2;
  Button1.Enabled:=EnabledJpeg2K;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  UnloadOpenJp2;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
  Label2.caption:=IntToStr(TrackBar1.Position);
end;

end.
